
#   Copyright (C) 2006 David G. Jacobowitz 
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

package filewrap;
use Exporter 'import';
@EXPORT_OK = qw(open_read isUrl);

use strict;
use LWP::UserAgent;
use IO::String;
use FileHandle;

sub open_read {
 my $fname = shift;
 my $fh = FileHandle->new();
 my $ok = 0;
 if (isUrl($fname)) {
  my $ua = LWP::UserAgent->new;
  $ua->agent("AtAtsStatistics/0.1");
  my $req = HTTP::Request->new(GET => $fname);
  my $res = $ua->request($req);
  if ($res->is_success()) {
   my $s = $res->content;
   $s =~ s/\r//g;
   $fh = IO::String->new($s);   
   $ok = 1;
   return ($ok,$fh);
  } else {
   $ok = 0;
   return($ok,undef);
  }
 } else {
#  print "REGULAR OPEN\n";
  $ok = open($fh,"<" . $fname);
#  print "ok is $ok fname is $fname\n";
 }
 return ($ok,$fh);
}


sub isUrl {
 my $s = shift;
 return ($s =~ /^([hH][tT][tT][pP]|[fF][tT][pP])\:\/\//);
}

1;

